/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: RA-integration
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2000-12-15, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  *       - works
  * -------------------------------------------------------------------
  * TODO:
  *       - make answer better
  */
package jaugment2.RememberanceAgent;

  //JDK
import java.rmi.server.UnicastRemoteObject;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.MarshalledObject;
import java.io.Serializable;
import java.lang.IllegalStateException;
//import java.net.URL;
  //JINI
//import net.jini.core.event.RemoteEventListener;
//import net.jini.core.lease.LeaseDeniedException;
//import net.jini.core.lease.Lease;
import net.jini.admin.Administrable;
  //project
import jaugment2.jini.simpleService.simpleAdministrator;
import jaugment2.helpers.Logger;
import jaugment2.RememberanceAgent.RememberanceAgentServiceProxyIF.Answer;

//helper-mark for configure to determine that rmic needs to be executed for this file
//rmimakehelper


/**
 * A service wrapping the MIT-Remenberance-Agent and alowing to
 * integrate it into other services (like the text-editor)
 */
public class RememberanceAgentServiceProxy extends UnicastRemoteObject implements Administrable, Serializable, Remote, RememberanceAgentServiceProxyIF
{
 private RememberanceAgentService service;


  RememberanceAgentServiceProxy(RememberanceAgentService service ) throws RemoteException
  {
   try
     {
      this.service = service;
     }
   catch(Exception e)
     {
      Logger.err.println("Exception in RememberanceAgentServiceProxy::RememberanceAgentServiceProxy() has the Message: "+e.getMessage());
      e.printStackTrace(Logger.err);
     }
  }


  /*public void pause() throws RemoteException, IllegalArgumentException, IllegalStateException
  {
   service.pause();
  } */




 /**
   * Returns an object that implements our administration-interfaces.
   *
   * @throws java.rmi.RemoteException
   * @see JoinAdmin
   */
  public Object getAdmin() throws RemoteException
  {
   return(new simpleAdministrator(service));
  }


  //--------------------------------------------

/*
  public static class Answer
  {
   public int docid;
   public String line;
   public Answer(int docid, String line)
   {
    this.docid = docid;
    this.line = line;
   }
   public String toString()
   {
    return("Answer["+docid+"] \""+line+"\"");
   }
  }
*/




  public Answer[] ask(String question, int numretvals) throws RemoteException
  {
   return(service.ask(question, numretvals));
  }

  public String getDocument(int docid, String base)   throws RemoteException
  {
   return(service.getDocument(docid, base));
  }



}
